#include "moodlight1.h"

void ports_init()
{
	DDRB = 0xFF;

	PORTD |= (1<<PD2);
}

void adc_init()
{
	//ADC-Kanal_0 ist verbunden
	ADMUX |= (1<<REFS0);						//Referenzspannung ist AVCC (5V)
	
	ADCSRA |= (1<<ADEN);					// ADC ein
	ADCSRA |= ((1<<ADPS2) | (1<<ADPS1));	// Vorteiler = 64 (125 kHz @ 8 MHz)
	ADCSRA |= (1<<ADIE);					// ADC-Interrupt aktiviert
	ADCSRA |= (1<<ADFR);					// free running aktiv
	ADCSRA |= (1<<ADSC);					// Wandlungen starten...
}

void interrupt_init()
{
	MCUCR |= (1<<ISC01);
	GICR |= (1<<INT0);
	sei();
}

void pwm_timer_init()
{
// PWM MODE SELECT
	// Fast PWM, TOP = 0xFF
	TCCR1A |= (1<<WGM10);
	TCCR1B |= (1<<WGM12);

	// Fast PWM, TOP = 0xFF
	TCCR2 |= (1<<WGM20);
	TCCR2 |= (1<<WGM21);


// OUTPUT BEHAVIOR
	// Clear OC1A on Compare Match,
	// Set OC1A at bottom.
	TCCR1A |= (1<<COM1A1);

	// Clear OC1B on Compare Match,
	// Set OC1B at bottom.
	TCCR1A |= (1<<COM1B1);

	// Clear OC2A on Compare Match,
	// Set OC2A at bottom.
	TCCR2 |= (1<<COM21);


// Prescaler einstellen, Timer(1+2) starten
	//TCCR1B |= (1<<CS11);		// PS = 8
	//TCCR2 |= (1<<CS21);		// PS = 8
	TCCR1B |= ( (1<<CS11) | (1<<CS10) );	// PS = 64
	TCCR2 |= (1<<CS22);						// PS = 64
}

