#include "moodlight1.h"


// nderung der Datentypn von richtung, color, phase, mode, temp1, temp2
unsigned char cosinus[] = {
1,1,1,1,1,1,1,1,
1,2,2,2,2,2,3,3,
3,4,4,4,5,5,5,6,
6,7,7,8,8,9,9,10,
10,11,12,12,13,14,14,15,
16,16,17,18,19,20,20,21,
22,23,24,25,26,27,28,29,
30,31,32,33,34,35,36,37,
38,39,40,41,42,44,45,46,
47,48,50,51,52,53,55,56,
57,58,60,61,62,64,65,66,
68,69,71,72,73,75,76,78,
79,80,82,83,85,86,88,89,
91,92,94,95,97,98,100,101,
103,104,106,107,109,110,112,114,
115,117,118,120,121,123,124,126,
128,129,131,132,134,135,137,138,
140,141,143,145,146,148,149,151,
152,154,155,157,158,160,161,163,
164,166,167,169,170,172,173,175,
176,177,179,180,182,183,184,186,
187,189,190,191,193,194,195,197,
198,199,200,202,203,204,205,207,
208,209,210,211,213,214,215,216,
217,218,219,220,221,222,223,224,
225,226,227,228,229,230,231,232,
233,234,235,235,236,237,238,239,
239,240,241,241,242,243,243,244,
245,245,246,246,247,247,248,248,
249,249,250,250,250,251,251,251,
252,252,252,253,253,253,253,253,
254,254,254,254,254,254,254,254
};

unsigned char color[7];
volatile unsigned char mode = 0;
unsigned char pointer_rt;
unsigned char pointer_gn;
unsigned char pointer_bl;
volatile unsigned int adc_wert_os;

unsigned char ee_mode			EEMEM;


//######### Anfang des UP led_test #########
//Routine zum kurzen Test der einzelnen LEDS
//Jede LED-Kombination leuchtet einmal kurz
//auf, wenn nach Power-Up der Kopf gedrckt ist.
void led_test()
{
	color[0] = rt;
	color[1] = ge;
	color[2] = gr;
	color[3] = cy;
	color[4] = bl;
	color[5] = mg;
	color[6] = we;

	if( !(PIND & (1<<PIND2)) )
	{
		for(unsigned char temp1 = 0; temp1 < 7; temp1++)
		{
			PORTB = color[temp1];

			for(unsigned char temp2 = 0; temp2 < 15; temp2++)
			{
				_delay_ms(100);
			}
		}
		
		PORTB = 0x00;

		// warten auf Loslassen des Tasters
		//while( !(PIND & (1<<PIND2)) )
		//{
		//;
		//}
		//_delay_ms(20);
	}
}
//######### Ende des UP led_test #########



void warten(unsigned int delay)
{
	unsigned char mode_old = mode;

	for(; ((delay >= 1) && (mode_old == mode)); delay--)
	{
		_delay_ms(1);
	}
}

void pwm_timer_aus()
{
	TCCR1A &= ~(1<<COM1A1);
	TCCR1A &= ~(1<<COM1B1);
	TCCR2 &= ~(1<<COM21);
}

unsigned char pwm_werte_laden(	unsigned char soft_richtung,
								unsigned char *array_pointer)
{
	// hochzhlen
	if(soft_richtung == 1)
	{
		if(*array_pointer < max)
		{
			(*array_pointer)++;
		}
	}

	// runterzhlen
	else if(soft_richtung == 2)
	{
		if(*array_pointer > min)
		{
			(*array_pointer)--;
		}
	}

return cosinus[*array_pointer];
}


unsigned char phasen()
{
//Phasen zum Durchgehen der Farbspektrums
//Startzustnde definiert in "vars_init()",
//Jeweils zwei Bit innerhalb des Bytes definieren das Verhalten fr eine Farbe,
//	Bit [1-0]:	Rot
//	Bit [3-2]:	Grn
//	Bit [5-4]:	Blau
//"0" => kein Blendvorgang
//"1" => Einblenden
//"2" => Ausblenden
	static unsigned char blendphase = 0;

	blendphase++;

	if(blendphase > 7)
	{
		blendphase = 1;
	}

	switch(blendphase)
	{
		case 1:
			return 0b000100;		// rot an, grn einblenden
			break;

		case 2:
			return 0b000010;		// grn an, rot  ausblenden
			break;

		case 3:
			return 0b010000;		// grn an, blau einblenden
			break;
		
		case 4:
			return 0b001000;		// blau an, grn ausblenden
			break;
		
		case 5:
			return 0b000001;		// blau an, rot  einblenden
			break;

		case 6:
			return 0b000100;		// blau an, rot an, grn einblenden
			break;

		case 7:
			return 0b101000;		// rot an, blau ausblenden, grn ausblenden
			break;
	}

	return 0;
}
//###################################



int main(void)
{
	ports_init();		// Aufruf der Initialisierung der Ports
	led_test();			// Aufruf der LED-Test-Routine
	adc_init();			// Aufruf der Initialisierung des ADC
	interrupt_init();	// Aufruf der Initialisierung der Interrupts

	mode = eeprom_read_byte(&ee_mode);

	if(mode > mode_max)
		mode = 0;

	//##### Anfang der Haupt-Endlos-Schleife #####
	while(1)					
	{	
		mode_select();
	}
}
//##### Ende der Haupt-Endlos-Schleife #####

void mode_select()
{
	if(mode == softfade)
	{
		soft_fade();			// Aufruf des Softfade-UPs
	}

	else if(mode == phaseshift)
	{
		phaseshift_120_degrees();			// Aufruf des Hardfade-UPs
	}

	else if(mode == nofade)
	{
		no_fade();			// Aufruf des Hardfade-UPs
	}

	else if(mode == strobe)
	{
		strobo();				// Aufruf des Stroboskop-UPs
	}

	else if((mode > strobe) && (mode < farbwahl))
	{
		einzelnd();				// Aufruf des Einzel-LED-UPs
	}

	else if(mode == farbwahl)
	{
		farb_wahl();
	}
}

//##### Anfang des UPs soft_fade #####
// Kontinuierlicher Durchlauf des RBG-
// Farbspektrums durch sanftes berblenden
// der LEDs. Geschwindigkeit in Abhngig-
// keit des Potis einstellbar.
void soft_fade()
{
	pointer_rt = max;
	pointer_gn = min;
	pointer_bl = min;

	OCR1A = cosinus[pointer_rt];
	OCR1B = cosinus[pointer_gn];
	OCR2 = cosinus[pointer_bl];

	pwm_timer_init();			// Aufruf der Timer-Initialisierung

	while(mode == softfade)
	{
		unsigned char richtung = phasen();

		for(unsigned int temp = min; (temp < max) && (mode == softfade); temp++)
		{
			OCR1A	= pwm_werte_laden(	(richtung & 0x03),			(unsigned char*) &pointer_rt);
			OCR1B	= pwm_werte_laden(	((richtung >> 2) & 0x03),	(unsigned char*) &pointer_gn);
			OCR2	= pwm_werte_laden(	((richtung >> 4) & 0x03),	(unsigned char*) &pointer_bl);

			warten((adc_wert_os >> 6) + 5);
		}
	}
}
//##### Ende des UPs soft_fade #####


//##### Anfang des UPs 120_degrees #####
// Kontinuierlicher Durchlauf des RBG-
// Farbspektrums durch sanftes berblenden
// der LEDs. Geschwindigkeit in Abhngig-
// keit des Potis einstellbar.
void phaseshift_120_degrees()
{
	pointer_rt = min;	// 0 Grad
	pointer_gn = 170;	// +270 Grad (-120 Grad)
	pointer_bl = 170;	// +120 Grad (-240 Grad)

	unsigned char richtung = 0b00011001;

	OCR1A = cosinus[pointer_rt];
	OCR1B = cosinus[pointer_gn];
	OCR2 = cosinus[pointer_bl];

	pwm_timer_init();			// Aufruf der Timer-Initialisierung

	while(mode == phaseshift)
	{
		OCR1A	= pwm_werte_laden(	(richtung & 0x03),			(unsigned char*) &pointer_rt);
		OCR1B	= pwm_werte_laden(	((richtung >> 2) & 0x03),	(unsigned char*) &pointer_gn);
		OCR2	= pwm_werte_laden(	((richtung >> 4) & 0x03),	(unsigned char*) &pointer_bl);

		if(pointer_rt == max)
		{
			richtung ^= 0b00000011;
		}

		else if(pointer_rt == min)
		{
			richtung ^= 0b00000011;
		}

		if(pointer_gn == max)
		{
			richtung ^= 0b00001100;
		}

		else if(pointer_gn == min)
		{
			richtung ^= 0b00001100;
		}

		if(pointer_bl == max)
		{
			richtung ^= 0b00110000;
		}

		else if(pointer_bl == min)
		{
			richtung ^= 0b00110000;
		}

		warten((adc_wert_os >> 6) + 1);
	}
}
//##### Ende des UPs 120_degrees #####


//##### Anfang des UPs no_fade #####
// Kontinuierlicher Durchlauf ohne ber-
// blenden der LEDs. Geschwindigkeit
// ber Poti einstellbar.

void no_fade()
{
	pwm_timer_aus();

	while(mode == nofade)
	{
		for(unsigned char temp = 0; (temp < 7) && (mode == nofade); temp++)
		{
			PORTB = color[temp];

			warten(adc_wert_os + 10);
		}
	}
}
//##### Ende des UPs no_fade #####






//##### Anfang des UPs strobo #####
// Stroboskop-Modus, alle LEDs blitzen
// gemeinsam kurz auf, Geschwindigkeit
// des Bitzens ber Poti einstellbar

void strobo()
{
	pwm_timer_aus();

	while(mode == strobe)
	{
		PORTB = we;
		_delay_ms(15);
		
		// Dauerhaft an, wenn Poti am (fast) Anschlag
		if(adc_wert_os > 2)
		{
			PORTB = 0x00;
			warten(adc_wert_os + 5);
		}
	}
}
//##### Ende des UPs strobo #####






//##### Anfang des UPs einzelnd #####
// LEDs blenden einzelnd auf und wieder
// ab, Blend-Geschwindigkeit ber Poti
// einstellbar. Weiterschalten der LEDs
// durch Tastendruck.

void einzelnd()
{
	pwm_timer_init();

	unsigned char richtung = 1;

	while((mode > strobe) && (mode < farbwahl))
	{

		for(unsigned int temp = min; (temp < max) && (mode < farbwahl); temp++)
		{
			if(mode == einzel_rt)
			{
				OCR1B = min;
				OCR2 = min;		

				OCR1A = pwm_werte_laden( (richtung & 0x03), (unsigned char*) &pointer_rt);
			}
	//---------------------------

			else if(mode == einzel_gr)
			{
				OCR1A = min;
				OCR2 = min;

				OCR1B = pwm_werte_laden( ((richtung >> 0) & 0x03), (unsigned char*) &pointer_gn);
			}
	//--------------------------

			else if(mode == einzel_bl)
			{
				OCR1A = min;
				OCR1B = min;

				OCR2 = pwm_werte_laden(	((richtung >> 0) & 0x03), (unsigned char*) &pointer_bl);
			}
	//--------------------------
	
			warten((adc_wert_os >> 6) + 1);
		}

		if(richtung == 1)
		{
			richtung = 2;
		}

		else if(richtung == 2)
		{
			richtung = 1;
		}

	}// while(mode > strobe && mode < farbwahl) zu

}// einzeld() zu
//##### ENDE des UPs einzelnd #####





//##### Anfang des UPs farb_wahl #####
// Farben werden direkt ber Poti-
// stellung gemischt, automatisches
// Blenden findet nicht statt.

void farb_wahl()
{
	int temp = 0;

	pwm_timer_init();

	while(mode == farbwahl)
	{	
		temp = adc_wert_os;

		if(temp >= 1707)
		{
			temp -= 1707;

			temp = ((3 * temp) >> 2);

			OCR1B = cosinus[(max - temp)];

			OCR1A = max;
			OCR2 = min;	
		}

		else if((temp < 1707) && (temp >= 1366))
		{
			temp -= 1366;
		
			temp = ((3 * temp) >> 2);

			OCR1A = cosinus[temp];

			OCR1B = max;
			OCR2 = min;
		}

		else if((temp < 1366) && (temp >= 1024))
		{
			temp -= 1024;
		
			temp = ((3 * temp) >> 2);

			OCR2 = cosinus[(max - temp)];

			OCR1A = min;
			OCR1B = max;
		}

		else if((temp < 1024) && (temp >= 683))
		{
			temp -= 683;
		
			temp = ((3 * temp) >> 2);

			OCR1B = cosinus[temp];

			OCR1A = min;
			OCR2 = max;
		}

		else if((temp < 683) && (temp >= 342))
		{
			temp -= 342;
		
			temp = ((3 * temp) >> 2);

			OCR1A = cosinus[(max - temp)];

			OCR1B = min;
			OCR2 = max;
		}

		else if(temp < 342)
		{
			temp = ((3 * temp) >> 2);

			OCR2 = cosinus[temp];

			OCR1A = max;
			OCR1B = min;
		}	
	}
}
//##### ENDE des UPs farb_wahl #####





//#+#+#+#+#+#+#+#+#+#+#+#+#++#+#+#+#+#+#+#++#+#+#+#+#+#+
	


ISR(ADC_vect)
{
	// Es werden 4 Wandlungen durchgefhrt, um "oversampling" zu betreiben.
	// Anschlieende Division durch 2 -> Erzeugung einer "Pseudoauflsung" von 11 Bit
	static unsigned char l_wandlungen = 0;
	static unsigned int l_adc_wert = 0;

	l_adc_wert += ADCW;
	l_wandlungen++;

	if(l_wandlungen > 3)
	{
		adc_wert_os = (l_adc_wert >> 1);
		
		l_adc_wert = 0;
		l_wandlungen = 0;
	}
}


ISR(INT0_vect)
{
	_delay_ms(100);

	if(!(PIND & (1<<PIND2)))
	{
		mode++;
		adc_wert_os = 0;

		if(mode > mode_max)
		{
			mode = 0;
		}
	}

	eeprom_write_byte(&ee_mode, mode);

	_delay_ms(20);
	PORTB = 0x00;
}
